"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _mocha = _interopRequireDefault(require("mocha"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class EnhancedMocha extends _mocha.default {
  loadFiles(fn) {
    const {
      suite
    } = this;
    suite.suites.length = 0;
    suite.tests.length = 0;

    try {
      const [file] = this.files;

      if (module.hot) {
        module.hot.accept(file, () => {
          if (this.watching) {
            if (!this.running) this.run();else this.outdated = true;
          }
        });
      }

      suite.emit('pre-require', global, file, this); // eslint-disable-next-line global-require, import/no-dynamic-require

      suite.emit('require', require(file), file, this);
      suite.emit('post-require', global, file, this);
    } catch (e) {
      suite.addTest(new _mocha.default.Test('fix test errors', () => {
        throw e;
      }));
    }

    if (fn) {
      fn();
    }
  }

  watch() {
    this.outdated = false;
    this.running = true;
    this.watching = true; // reinit ui to fix ui bugs

    this.ui(this.options.ui); // run the tests

    this.run(() =>
    /* failures */
    {
      this.running = false;
      if (this.outdated) this.watch();
    });

    if (module.hot) {
      // Don't exit the process
      setInterval(() => {}, 100000);
    }
  }

}

exports.default = EnhancedMocha;